clear all
close all
clc

[nombre dire]=uigetfile('*.jpg','Abrir');
if nombre == 0
    return
end

imagen=imread(fullfile(dire,nombre));
%leo la imagen
%imagen=imread('pia.jpg');
% capa_roja=imagen(:,:,1);
% capa_verde=imagen(:,:,2);
% capa_azul=imagen(:,:,3);
%extraigo cada capa de la imagen RGB
[capa_roja capa_verde capa_azul]=capas(imagen);
% muestro la imagen en RGB
figure(1)
imshow(imagen)
title('Imagen RGB')

% hallo el humbral con el mtodo otsu para cada capa
Tr=graythresh(capa_roja);
Tg=graythresh(capa_verde);
Ta=graythresh(capa_azul);

% muestro cada una de las capas RGB de la imagen
figure(2)

% muestra capa roja
subplot(4,1,1)
imshow(capa_roja)
title('capa roja')

% muestra capa verde
subplot(4,1,2)
imshow(capa_verde)
title('capa verde')

% muestra capa azul
subplot(4,1,3)
imshow(capa_azul)
title('capa azul')


% muestra imagen en escala de grises
gray=rgb2gray(imagen);
subplot(4,1,4)
imshow(gray)
title('Imagen en escala de gris')


% Histograma de cada capa
figure(3)

%Histograma capa roja
subplot(411)
imhist(capa_roja)
title('capa roja')

%Histograma capa verde
subplot(4,1,2)
imhist(capa_verde)
title('capa verde')

%%Histograma capa azul
subplot(4,1,3)
imhist(capa_azul)
title('capa azul')

%Histograma imagen en escala de grises
gray=rgb2gray(imagen);
subplot(4,1,4)
imhist(gray)
title('Imagen en escala de gris')

% segmentacin de la imagen usando umbral (binarizacin)
% como el fondo es blanco utilizo la segmentacion sobre la capa azul
segazul=im2bw(capa_azul,Ta);
% muestro imagen binarizada 
figure(4)
imshow(segazul)

% invierto los valores en la imagen binarizada (cero por uno y uno por cero) 
%para luego segmentar la imagen haciendo multiplicacion con la imagen
%original
segazulinv=1-segazul;
% muestro imagen binarizada inversa
figure(5)
imshow(segazulinv)

% paso la imagen binarizada inversa a formato double para multiplicarla
segazulinv=im2double(segazulinv);

% cada capa la paso a formato double para multiplicarla
capa_rojadou=im2double(capa_roja);
capa_verdeu=im2double(capa_verde);
capa_azulu=im2double(capa_azul);

% creo las nuevas capas multiplicando cada capa RGB por la imagen invertida
% lo cual me permite mostrar en color la fruta segmentada del fondo
segcaparoja=segazulinv.*capa_rojadou;
segcapaverde=segazulinv.*capa_verdeu;
segcapaazul=segazulinv.*capa_azulu;

% concateno la nuevas capas para crear la imagen final en color
imagenseg(:,:,1)=segcaparoja;
imagenseg(:,:,2)=segcapaverde;
imagenseg(:,:,3)=segcapaazul;

% muestro la fruta segmentada del fondo
figure(6)
imshow(imagenseg)

%%
% creo elemento estructural 
SE=strel('square',30);

% hago deteccin de bordes utilizando un mtodo de derivada sobel
% puedo utilizar los siguientes metodos 'canny', 'prewitt',
% 'roberts','log', 'sobel', 'zerocross'.
im_edge=edge(capa_azul,'zerocross');

% hago dilatacin en la imagen
im_dilate=imdilate(segazulinv,SE);

% creo elemento estructural
SA=strel('square',20);

% hago erosin en la imagen
im_erode=imerode(im_dilate,SA);

% muestro deteccin de bordes
figure(7)
imshow(im_edge)
title('Deteccin de bordes')

%muestro imagen donde se aplico dilatacin
figure(8)
imshow(im_dilate)
title('Imagen Dilatada')

%muestro imagen donde se aplico erosin
figure(9)
imshow(im_erode)
title('Imagen Erosionada')

figure (10)
imshow(segazulinv)
title('Segmentacin')

%%
%Correccin de la imagen segmentada con el algorigmo de erocin

% paso la imagen binarizada inversa a formato double para multiplicarla
segazulinv=im2double(im_erode);

% cada capa la paso a formato double para multiplicarla
capa_rojadou=im2double(capa_roja);
capa_verdeu=im2double(capa_verde);
capa_azulu=im2double(capa_azul);

% creo las nuevas capas multiplicando cada capa RGB por la imagen invertida
% lo cual me permite mostrar en color la fruta segmentada del fondo
segcaparoja=segazulinv.*capa_rojadou;
segcapaverde=segazulinv.*capa_verdeu;
segcapaazul=segazulinv.*capa_azulu;

% concateno la nuevas capas para crear la imagen final en color
imagenseg(:,:,1)=segcaparoja;
imagenseg(:,:,2)=segcapaverde;
imagenseg(:,:,3)=segcapaazul;

% muestro la fruta segmentada del fondo

figure(11)
imshow(im_erode)

figure(12)
imshow(imagenseg)

figure(13)
imshow(imagen)
%%

%L = BWLABEL(im_erode,8); 
figure(11)
imshow(segazulinv)

[L,NUM] = BWLABEL(segazulinv,8); 

max(max(L))
% STATS = REGIONPROPS(2,'Area');
map=[0 0 0;jet(max(max(L)))];
imshow(L+1,map)
stats = imfeature(L,'Area');
propiedades=regionprops(L, 'Area','EulerNumber','Orientation','BoundingBox','Extent','Perimeter','Centroid','Extrema', 'PixelIdxList', 'ConvexArea', 'FilledArea' ,'PixelList', 'ConvexHull', 'FilledImage', 'Solidity', 'ConvexImage', 'Image', 'SubarrayIdx', 'Eccentricity' , 'MajorAxisLength', 'EquivDiameter' ,'MinorAxisLength'   );




stats(1).Area
%stats(2).Area


%% tratamiento sobre imagen ya segmentada


[capa_roja2 capa_verde2 capa_azul2]=capas(imagenseg);

% muestra capa roja
subplot(4,1,1)
imshow(capa_roja2)
title('capa roja2')

% muestra capa verde
subplot(4,1,2)
imshow(capa_verde2)
title('capa verde2')

% muestra capa azul
subplot(4,1,3)
imshow(capa_azul2)
title('capa azul2')


% muestra imagen en escala de grises
gray2=rgb2gray(imagenseg);
subplot(4,1,4)
imshow(gray2)
title('Imagen en escala de gris')


% Histograma de cada capa
figure(3)

%Histograma capa roja
subplot(411)
imhist(capa_roja2)
title('capa roja2')

%Histograma capa verde
subplot(4,1,2)
imhist(capa_verde2)
title('capa verde2')

%%Histograma capa azul
subplot(4,1,3)
imhist(capa_azul2)
title('capa azul2')

%Histograma imagen en escala de grises

subplot(4,1,4)
imhist(gray2)
title('Imagen en escala de gris')

figure(14)
imshow(capa_roja2)


% me di cuenta como puedo reconocer bordes con resta de imgenes.
figure(15)
imshow(capa_azul2)

pruebaborde=im2bw(capa_azul2,0.3);
% muestro imagen binarizada 
figure(16)
imshow(pruebaborde)

%% pasar la imagen a HSV

imagenhsv=rgb2hsv(imagen);
imshow(imagenhsv)

[tono saturacion valor]=capas(imagenhsv);

figure(15)

% muestra capa h
subplot(3,1,1)
imshow(tono)
title('H')

% muestra capa s
subplot(3,1,2)
imshow(saturacion)
title('S')

% muestra capa v
subplot(3,1,3)
imshow(valor)
title('V')


















